/*******************************************************************************
 * Copyright (c) 1991, 2021 IBM Corp. and others
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] http://openjdk.java.net/legal/assembly-exception.html
 *
 *  SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
 *******************************************************************************/

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.NullPointerDereference;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: direntPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the direntPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=dirent.class)
public class direntPointer extends StructurePointer {

	// NULL
	public static final direntPointer NULL = new direntPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected direntPointer(long address) {
		super(address);
	}

	public static direntPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static direntPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static direntPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}

		return new direntPointer(address);
	}

	public direntPointer add(long count) {
		return direntPointer.cast(address + (dirent.SIZEOF * count));
	}

	public direntPointer add(Scalar count) {
		return add(count.longValue());
	}

	public direntPointer addOffset(long offset) {
		return direntPointer.cast(address + offset);
	}

	public direntPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public direntPointer sub(long count) {
		return direntPointer.cast(address - (dirent.SIZEOF * count));
	}

	public direntPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public direntPointer subOffset(long offset) {
		return direntPointer.cast(address - offset);
	}

	public direntPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public direntPointer untag(long mask) {
		return direntPointer.cast(address & ~mask);
	}

	public direntPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return dirent.SIZEOF;
	}

	// Implementation methods

	// U64 d_ino
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_d_inoOffset_", declaredType="U64")
	public UDATA d_ino() throws CorruptDataException {
		return new U64(getLongAtOffset(dirent._d_inoOffset_));
	}

	// U64 d_ino
	public UDATAPointer d_inoEA() throws CorruptDataException {
		if (address == 0) {
			throw new NullPointerDereference();
		}

		return UDATAPointer.cast(address + dirent._d_inoOffset_);
	}

	// U8[] d_name
	public U8Pointer d_nameEA() throws CorruptDataException {
		if (address == 0) {
			throw new NullPointerDereference();
		}

		return U8Pointer.cast(address + dirent._d_nameOffset_);
	}

	// U16 d_namlen
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_d_namlenOffset_", declaredType="U16")
	public U16 d_namlen() throws CorruptDataException {
		return new U16(getShortAtOffset(dirent._d_namlenOffset_));
	}

	// U16 d_namlen
	public U16Pointer d_namlenEA() throws CorruptDataException {
		if (address == 0) {
			throw new NullPointerDereference();
		}

		return U16Pointer.cast(address + dirent._d_namlenOffset_);
	}

	// U16 d_reclen
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_d_reclenOffset_", declaredType="U16")
	public U16 d_reclen() throws CorruptDataException {
		return new U16(getShortAtOffset(dirent._d_reclenOffset_));
	}

	// U16 d_reclen
	public U16Pointer d_reclenEA() throws CorruptDataException {
		if (address == 0) {
			throw new NullPointerDereference();
		}

		return U16Pointer.cast(address + dirent._d_reclenOffset_);
	}

	// U64 d_seekoff
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_d_seekoffOffset_", declaredType="U64")
	public UDATA d_seekoff() throws CorruptDataException {
		return new U64(getLongAtOffset(dirent._d_seekoffOffset_));
	}

	// U64 d_seekoff
	public UDATAPointer d_seekoffEA() throws CorruptDataException {
		if (address == 0) {
			throw new NullPointerDereference();
		}

		return UDATAPointer.cast(address + dirent._d_seekoffOffset_);
	}

	// U8 d_type
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_d_typeOffset_", declaredType="U8")
	public U8 d_type() throws CorruptDataException {
		return new U8(getByteAtOffset(dirent._d_typeOffset_));
	}

	// U8 d_type
	public U8Pointer d_typeEA() throws CorruptDataException {
		if (address == 0) {
			throw new NullPointerDereference();
		}

		return U8Pointer.cast(address + dirent._d_typeOffset_);
	}

}
